/*
 *
 * Code sniplet to compute the orthogonal 2D DCT II
 *
 * Copyright(c) 2012 Miguel Colom.
 * miguel.colom@cmla.ens-cachan.fr
 *
 * This file may be licensed under the terms of of the
 * GNU General Public License Version 2 (the ``GPL'').
 *
 * Software distributed under the License is distributed
 * on an ``AS IS'' basis, WITHOUT WARRANTY OF ANY KIND, either
 * express or implied. See the GPL for the specific language
 * governing rights and limitations.
 *
 * You should have received a copy of the GPL along with this
 * program. If not, go to http://www.gnu.org/licenses/gpl.html
 * or write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 */

  double *FFT_in = new double[w*w];
  double *FFT_out = new double[w*w];

  fftw_plan fft_plan = fftw_plan_r2r_2d(w, w,
                            FFT_in, FFT_out,
                            FFTW_REDFT10, FFTW_REDFT10,
                            FFTW_ESTIMATE);

  for (int y = 0; y < Ny - w + 1; y++) {
    for (int x = 0; x < Nx - w + 1; x++) {
      // Copy block
      for (int j = 0; j < w; j++) {
        for (int i = 0; i < w; i++) {
          FFT_in[j*w+i] = u[(y+j)*Nx+x+i];
        }
      }

      // Transform block with FFTW
      fftw_execute(fft_plan);
        
      // Normalize FFTW output in order to get a orthonormal DCT
      // All {(i, j)} pairs
      for (int j = 0; j < w; j++) {
        for (int i = 0; i < w; i++) {
          FFT_out[j*w+i] /= 2 * w;
        }
      }
      //
      // {(i, j)} with i == 0 or j == 0
      for (int j = 0; j < w; j++) {
        int i = 0;
        FFT_out[j*w+i] /= sqrt(2);
      }
      for (int i = 0; i < w; i++) {
        int j = 0;
        FFT_out[j*w+i] /= sqrt(2);
      }
    }
  }

//delete FFT_in;
//delete FFT_out;

